package model;

import extvisitor.*;

/**
 * Algorithm to retrieve the index value associated with the calling host.  
 * Here, the type of the host is FSMstate, which has an index type of Integer.
 * @author Stephen Wong (c) 2010
 *
 */
public class GetIdxAlgo extends AExtVisitor<Integer, Integer, Object, FSMstate> {
	
	/**
	 * Singleton instance of this class.
	 */
	public static final GetIdxAlgo Singleton = new GetIdxAlgo();
	
	/**
	 * Private constructor that defines the default case of this visitor as returning the index value used by the host
	 * when it calls this visitor's caseAt method.
	 */
	private GetIdxAlgo() {
		super(new IExtVisitorCmd<Integer, Integer, Object, FSMstate>(){
			public <T extends IExtVisitorHost<Integer, ? super FSMstate>> Integer apply(Integer index, T host, Object... params) {
				return index;
			}
		});
	}
}
